/*
*	netkey on unix
*	
*	usage: netkey
*
*   compile:
*     	cc -o netkey netkey.c 9des.c des.c
*
*	coded by
*	    Kenar ( Kenji Arisawa )
*		E-mail: arisawa@aichi-u.ac.jp
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#define DESKEYLEN 7
#define NAMELEN 22

typedef unsigned char uchar;
uchar	*des9key(uchar *key);
int encrypt9(void *key, void *data, int len);
char *shcmd[2] = {"stty -echo", "stty echo; echo"};
#define des(key,t) encrypt9(key,t,8)

#ifdef DOS
int getch(void);
void readpwd(char *s)
{
	int c;
	while((c = getch()) != '\r')
		*s++ = c;
	*s = 0;
	puts("");
}
#else
#define echo(mode) system(shcmd[mode])
void readpwd(char *s)
{
	echo(0);
	gets(s);
	echo(1);
}
#endif

/* imported from plan9 - slitely modified -
   uchar p[NAMELEN]    --- password
   uchar key[DESKEYLEN] --- DES key
*/
int
pass2key(uchar *p, uchar *key)
{
        uchar buf[NAMELEN], *t;
        int i, n;

        n = strlen(p);
        if(n >= NAMELEN)
                n = NAMELEN-1;
        memset(buf, ' ', 8);
        t = buf;
        strncpy((char*)t, p, n);
        t[n] = 0;
        memset(key, 0, DESKEYLEN);
        for(;;){
                for(i = 0; i < DESKEYLEN; i++)
                        key[i] = (t[i] >> i) + (t[i+1] << (8 - (i+1)));
                if(n <= 8)
                        break;
                n -= 8;
                t += 8;
                if(n < 8){
                        t -= 8 - n;
                        n = 8;
                }
                des(des9key(key), t); /* encrypt(key,t,8) on plan9 */
        }
		return 1;
}



main()
{	uchar buf[80];
	uchar key9[DESKEYLEN];
	uchar *key;
	int i;

	fprintf(stderr,"password: ");
	readpwd(buf);
	pass2key(buf,key9);
	key = des9key(key9);
	fprintf(stderr,"challenge: ");
#ifdef DOS
	if(getenv("OS") == 0) getch(); /* Oh, dreadful!*/
#endif
	for(;;){
		memset(buf,0,8);
		gets(buf);
		if(strlen(buf) == 0) break;
		buf[7] = 0;
		des(key,buf);
		printf("response: ");
		for(i = 0; i < 4; i++) printf("%02x",buf[i]);
		puts("");
		fprintf(stderr,"challenge: ");
	}
}

